/* Copyright (C) 2002 GFRN systems

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   The latest version of this program may be found at
   http://CQiNet.sourceforge.net

   $Log: users.c,v $
   Revision 1.1.1.1  2002/08/10 20:33:41  wb6ymh
   initial import

*/

#include "common.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "avl.h"
#include "users.h"

struct avl_table *UserTree;
struct avl_table *UserIPAdrTree;

UserInfo *pUserDebug = NULL;

int Id = 1001;

void DeleteUser(UserInfo *pUser,int Virgin)
{
   D2PRINTF(("Deleting user \"%s\".\n",pUser->Callsign));
   if(pUser->HisAdr != NULL) {
      if(!Virgin && avl_find(UserIPAdrTree,pUser) != NULL) {
         avl_delete(UserIPAdrTree,pUser);
      }
      free(pUser->HisAdr);
   }

   if(!Virgin) {
      if(avl_delete(UserTree,pUser) == NULL) {
         LOG_ERROR(("DeleteUser(): avl_delete() failed to find user \"%s\".\n",
                    pUser->Callsign));
      }
   }

   if(pUser->Callsign != NULL) {
      free(pUser->Callsign);
   }

   if(pUser->NodeID != NULL) {
      free(pUser->NodeID);
   }

   if(pUser->Qth != NULL) {
      free(pUser->Qth);
   }

   if(pUser->Password != NULL) {
      free(pUser->Password);
   }
}

// User compares by callsign
int UserCompare(const void *avl_a,const void *avl_b,void *avl_param)
{
   UserInfo *p_a = (UserInfo *) avl_a;
   UserInfo *p_b = (UserInfo *) avl_b;

   return strcmp(p_a->Callsign,p_b->Callsign);
}

// User compares by callsign
int UserIPCompare(const void *avl_a,const void *avl_b,void *avl_param)
{
   UserInfo *p_a = (UserInfo *) avl_a;
   UserInfo *p_b = (UserInfo *) avl_b;

   return strcmp(p_a->HisAdr,p_b->HisAdr);
}

UserInfo *CreateNewUser(char *Callsign)
{
   char  NodeID[6];
   UserInfo *pUser = malloc(sizeof(UserInfo));

   if(pUser != NULL) {
      memset(pUser,0,sizeof(UserInfo));
      pUser->Callsign = strdup(Callsign);
      snprintf(NodeID,sizeof(NodeID),"%d",Id++);
      pUser->NodeID = strdup(NodeID);
   }
   return pUser;
}

